﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace LongTextColumnPOC
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new MainWindowViewModel();
        }

        private const int DoubleClick = 2;

        private void UIElement_OnMouseDown(object sender, MouseButtonEventArgs e)
        {
            if (e.ClickCount == DoubleClick && e.ChangedButton == MouseButton.Left)
            {
                var textBlock = sender as IAEATextBlock;

                if (textBlock != null)
                {
                    var data = textBlock.Tag as TestModel;
                    var window = new LongTextDialog
                    {
                        LongTextValue = textBlock.Text,
                        FieldName = "Comments",
                        IsLongTextReadOnly = data.IsEditable
                        
                    };

                    window.ShowDialog();

                    if (window.DialogResult.HasValue && window.DialogResult.Value)
                    {
                        textBlock.Text = window.LongTextValue;
                        window.OkButton.Command = textBlock.Command;
                        data.Description = window.LongTextValue;
                        window.OkButton.Command.Execute(data);
                    }
                }
            }
        }
    }
}
